# include "minigui.ch"

Function Main

public dbo := nil
public mysqldbo := nil
private nAtaTime := 200
private aTables := {}
set navigation extended
set date ansi
set century on

define window sql at 0,0 width 600 height 300 main title "MySQL2SQLite" on release iif(mysqldbo <> nil, mysqldbo:destroy(),) nosize nomaximize
   define frame mysqlframe
      row 10
      col 5
      width 270
      height 210
      caption "Source && MySQL Connection Details"
   end frame
   define label hostlabel
      row 30
      col 10
      width 100
      value "Host"
   end label
   define textbox host
      row 30
      col 110
      width 150
      value "localhost"
   end textbox
   define label userlabel
      row 60
      col 10
      width 100
      value "User"
   end label
   define textbox user
      row 60
      col 110
      width 150
      value ""
   end textbox
   define label passlabel
      row 90
      col 10
      width 100
      value "Password"
   end label
   define textbox pass
      row 90
      col 110
      width 150
      password .t.
   end textbox
   define button connect
      row 120
      col 10
      width 50
      caption "Connect"
      action connectdb()
   end button
   define label connection
      row 130
      col 70
      width 190
      value "No Connection"
      fontbold .t.
      fontcolor {255,0,0}
   end label
   define label dblabel
      row 160
      col 10
      width 100
      value "Select a DB"
   end label
   define combobox databases
      row 160
      col 110
      width 150
   end combobox
   define label sqldblabel
      row 190
      col 10
      width 100
      value "SQLite DB File"
   end label
   define textbox dbfname
      row 190
      col 110
      tabstop .f.
      readonly .t.
      width 100
   end textbox
   define button browsedbf
      row 190
      col 220
      width 50
      caption "Save"
      action browsefordbf()
   end button
   define label tablestatus
      row 30
      col 300
      width 250
   end label
   define progressbar tables
      row 60
      col 300
      width 250
      rangemin 0
      rangemax 100
   end progressbar
   define label recordstatus
      row 100
      col 300
      width 250
   end label
   define progressbar records
      row 130
      col 300
      rangemin 0
      rangemax 100
      width 250
   end progressbar
   define button export
      row 230
      col 275
      width 50
      caption "Convert"
      fontbold .t.
      action export2sqlite()
   end button
end window
sql.tables.visible := .f.
sql.records.visible := .f.
sql.center
sql.activate
Return nil

function connectdb
local databases := {}
local i := 0
sql.databases.deleteallitems()
if mysqldbo <> nil
   mysqldbo:destroy()
endif
mysqldbo := connect2mysqldb(alltrim(sql.host.value),alltrim(sql.user.value),alltrim(sql.pass.value))
if .not. empty(mysqldbo)
   sql.connection.value := "Successful!"
   sql.connection.fontcolor := {0,255,0}
   databases := mysql_sql(mysqldbo,"show databases")   
   for i := 1 to len(databases)
      sql.databases.additem(alltrim(databases[i,1]))
   next i
   if sql.databases.itemcount > 0
      sql.databases.value := 1
   endif
else
   sql.connection.value := "No Connection"
   sql.connection.fontcolor := {255,0,0}
endif
return nil

function browsefordbf
local fname := ""
fname := alltrim(PutFile({{"SQLite Files","*.db3"}},"Select a filename to convert to SQLite",,.f.,.f.))
if len(alltrim(fname)) == 0
   sql.dbfname.value := fname
   return nil
endif
if len(fname) > 4
   if .not. upper(substr(fname,len(fname)-3,4)) == ".DB3"
      fname := fname + ".db3"
   endif
else
   fname := fname + ".db3"
endif
sql.dbfname.value := alltrim(fname)
return nil      


function export2sqlite
local table := {}
local currow := {}
local structarr := {}
asize(aTables,0)
if sql.databases.value > 0
   mysqldbo:selectdb(alltrim(sql.databases.item(sql.databases.value)))
   IF mysqldbo:NetErr()
      msginfo(mysqldbo:ERROR())
      RETURN .f.
   ENDIF
   tables := mysql_sql(mysqldbo,"show tables")
   for i := 1 to len(tables)
      aadd(aTables,alltrim(tables[i,1]))
   next i
else
   msgstop("No MySQL DB is selected to convert!")
   return nil   
endif  
if len(alltrim(sql.dbfname.value)) == 0
   msgstop("You have to select a New SQLite DB filename! Press save button to select")
   return nil
endif
if file(sql.dbfname.value)
   if .not. msgyesno("SQLite file exists. Are you sure to overwrite?")
      return nil
   else
      delete file (sql.dbfname.value)   
   endif
endif
dbo := connect2db(sql.dbfname.value,.t.)   
if empty(dbo)
   msgstop("SQLite DB could not be created!")
   return nil
endif
/*
linesarr := {}
for i := 1 to 1//len(aTables)
   table := mysql_sql(mysqldbo,"show create table "+aTables[i])
   cSQL := table[1,2]
   cSQL := strtran(cSQL,"'","")
   cSQL := strtran(cSQL,"`","")
   
   finished := .f.
   do while .not. finished
      m := at(chr(10),cSQL)
      if m > 0
         if m == 1
            linestr := ""
         else
            linestr := substr(cSQL,1,m-1)
         endif
         cSQL := substr(cSQL,m+1,len(cSQL))
         aadd(linesarr,linestr)
      else
         linestr := cSQL
         finished := .t.
      endif
   enddo
   aadd(linesarr,cSQL)
   cSQL := ""
   for j := 1 to len(linesarr)
      if .not. (at("KEY",linesarr[j]) > 0 .or. at("UNIQUE KEY",linesarr[j]) > 0 .or. at("PRIMARY KEY",linesarr[j]) > 0)
         linesarr[j] := strtran(linesarr[j],"unsigned","")
         linesarr[j] := strtran(linesarr[j],"auto_increment","primary key")
         linesarr[j] := strtran(linesarr[j],"smallint","integer")
         linesarr[j] := strtran(linesarr[j],"tinyint","integer")
         linesarr[j] := strtran(linesarr[j],"int","integer")
         
         nOpBracket := at("(",linesarr[j]) 
         nClBracket := 0
         if nOpBracket > 0 .and. nOpBracket < len(linesarr[j])
            if val(substr(linesarr[j],nOpBracket+1,1)) > 0
               nClBracket := at(")",linesarr[j])
            endif
         endif
         if nOpBracket > 0 .and. nClBracket > 0
            linesarr[j] := strtran(linesarr[j],substr(linesarr[j],nOpBracket,nClBracket - nOpBracket))
         endif
         cSQL := cSQL + linesarr[j]
      endif
   next j         
   msginfo(cSQL)
next i
return nil

*/
sql.tablestatus.value := ""
sql.recordstatus.value := ""
sql.tables.visible := .t.
sql.records.visible := .t.
i := 0
tottables := len(aTables)
sql.tables.value := round(i/tottables,0)

set alter to "sqlite.sql"
set alter on

for i := 1 to tottables
   sql.tablestatus.value := "Table :"+alltrim(aTables[i])+" ("+alltrim(str(i))+" of "+alltrim(str(tottables))+")"
   sql.tables.value := round(i/tottables*100,0)
   table := mysql_sql(mysqldbo,"show columns from "+aTables[i])
   asize(structarr,0)
   nPri := 0
   for j := 1 to len(table)
      type1 := substr(table[j,2],1,iif(at("(",table[j,2])>0,at("(",table[j,2])-1,len(table[j,2])))
      if at("(",table[j,2])>0 .and. (upper(alltrim(type1)) == "CHAR" .or. upper(alltrim(type1)) == "VARCHAR")
         size1 := val(alltrim(substr(table[j,2],at("(",table[j,2])+1,(at(")",table[j,2])-at("(",table[j,2])))))
      else
         size1 := 0
      endif  
      aadd(structarr,{alltrim(table[j,1]),type1,size1,table[j,4],table[j,5],table[j,6]})
      if upper(alltrim(table[j,4])) == "PRI"
         nPri := nPri + 1
      endif
   next j
   lPrimary := .f.
   createsql := "Create table "+aTables[i]+" ("
   for j := 1 to len(structarr)
      createsql := createsql + structarr[j,1]+" "
      do case
         case upper(structarr[j,2]) == "TINYINT"
            createsql := createsql + "INTEGER" + " "
         case upper(structarr[j,2]) == "SMALLINT"
            createsql := createsql + "INTEGER" + " "
         case upper(structarr[j,2]) == "MEDIUMINT"
            createsql := createsql + "INTEGER" + " "
         case upper(structarr[j,2]) == "INT"
            createsql := createsql + "INTEGER" + " "
         case upper(structarr[j,2]) == "INTEGER"
            createsql := createsql + "INTEGER" + " "
         case upper(structarr[j,2]) == "BIGINT"
            createsql := createsql + "INTEGER" + " "
         case upper(structarr[j,2]) == "REAL"
            createsql := createsql + "REAL" + " "
         case upper(structarr[j,2]) == "DOUBLE"
            createsql := createsql + "REAL" + " "
         case upper(structarr[j,2]) == "FLOAT"
            createsql := createsql + "FLOAT" + " "
         case upper(structarr[j,2]) == "DECIMAL"
            createsql := createsql + "REAL" + " "
         case upper(structarr[j,2]) == "NUMERIC"
            createsql := createsql + "REAL" + " "
         case upper(structarr[j,2]) == "DATE"
            createsql := createsql + "DATE" + " "
         case upper(structarr[j,2]) == "TIME"
            createsql := createsql + "TIME" + " "
         case upper(structarr[j,2]) == "TIMESTAMP"
            createsql := createsql + "TIME" + " "
         case upper(structarr[j,2]) == "DATETIME"
            createsql := createsql + "DATETIME" + " "
         case upper(structarr[j,2]) == "YEAR"
            createsql := createsql + "INTEGER" + " "
         case upper(structarr[j,2]) == "CHAR"
            createsql := createsql + "CHAR" + iif(structarr[j,3]>0,"("+alltrim(str(structarr[j,3]))+")","")+" "
         case upper(structarr[j,2]) == "VARCHAR"
            createsql := createsql + "CHAR" + iif(structarr[j,3]>0,"("+alltrim(str(structarr[j,3]))+")","")+" "
         case upper(structarr[j,2]) == "TEXT"
            createsql := createsql + "TEXT" + " "
      endcase
      if upper(alltrim(structarr[j,4])) == "PRI"
         if nPri == 1
            createsql := createsql + "PRIMARY KEY" + " "
         endif
      endif
      if upper(alltrim(structarr[j,6])) == "AUTO_INCREMENT"
         if nPri == 1
            createsql := createsql + "AUTOINCREMENT" + " "
         endif   
      endif
      if j < len(structarr)
         createsql := createsql + ","
      endif
   next j
   createsql := createsql + ")"
   miscsql(dbo,createsql)
   ?createsql
   adata := {}
   adata := mysql_sql(mysqldbo,"select * from "+alltrim(atables[i]))
   totrecords := len(aData)
   if totrecords > 0
      nRecCount := 0
      cQstr := "BEGIN TRANSACTION;"   
      for j := 1 to totrecords
         sql.records.value := round(j/totrecords*100,0)
         sql.recordstatus.value := "Records :"+alltrim(str(j))+" of "+alltrim(str(totrecords))
         if nRecCount >= nAtaTime
            cQstr := cQstr + "COMMIT;"
            if .not. miscsql(dbo,cQstr)
               return nil
            endif      
            nRecCount := 0
            cQstr := ""
            cQstr := "BEGIN TRANSACTION;"   
         endif
         cQstr := cQstr + "insert into "+alltrim(aTables[i])+" ("
         for k := 1 to len(structarr)
            cQstr := cQstr + alltrim(structarr[k,1])
            if k < len(structarr)
               cQstr := cQstr + ","
            endif
         next k
         cQstr := cQstr + ") values "
         aRow := aData[j]
         cQstr := cQstr + "("
         for k := 1 to len(aRow)
            cQstr := cQstr + c2sql(aRow[k])
            if k < len(aRow)
               cQstr := cQstr + ","
            endif
         next k
         cQstr := cQstr + ");"
         nReccount := nRecCount + 1
      next j
      if nRecCount > 0
         cQstr := cQstr + "COMMIT;"
		 ?cQstr
         if .not. miscsql(dbo,cQstr)
            return nil
         endif      
      endif   
   endif
next i
sql.tables.visible := .f.
sql.tablestatus.visible := .f.
sql.records.visible := .f.
sql.recordstatus.visible := .f.
msginfo("Database tables are successfully created!")
set alter off
set alter to
return nil